"""
         Version 1.1.1
         *** minor correction
This is a module contanining some functions for
chapter 7 of the book python head first.
"""

import pickle
from athletelist import AthleteList

def get_coach_data (filename):
    """takes a filename as string and returns an instance of AthleteList"""
    try:
        with open(filename) as f:
            data = f.readline().strip().split(",") # obtain a formatted list
        return(AthleteList(data.pop(0), data.pop(0), data)) #instantiate and return
    except IOError as ioerr:
        print("File error: " + str(ioerr))
        return(None)

def put_to_store(files_list):
    """given a list of properly formatted filenames, imports each to an
       AthleteList object, adds them to a dictionary, pickles out and returns
       the dictionary.
    """
    all_athletes = {}
    for each_file in files_list:
        athlete = get_coach_data(each_file)
        all_athletes[athlete.name] = athlete
    try:
        with open("all_athletes.pickle", "wb") as all_ath:
            pickle.dump(all_athletes, all_ath)
    except IOError as ioerr:
        print("File error in get_from_store: " + str(ioerr))
    return(all_athletes)

def get_from_store():
    """search for the pickle file <all_athletes.pickle>, expected to hold a
       dictionary, and returns its contents.
    """
    try:
        with open("all_athletes.pickle", "rb") as all_ath:
            all_athletes = pickle.load(all_ath)
    except IOError as ioerr:
        print("File error in get_from_store: " + str(ioerr))
    return(all_athletes)
